package org.simantics.objmap;

import org.simantics.db.ReadGraph;
import org.simantics.db.Resource;
import org.simantics.db.WriteGraph;

/**
 * Contains rules for how a link should be created and maintained.
 * @author Hannu Niemist
 */
public interface ILinkType extends IMappingRule {
    /**
     * Creates a domain element based on known range element.
     */
	Resource createDomainElement(WriteGraph g, Object rangeElement) throws MappingException;
	
	/**
     * Creates a range element based on known domain element.
     */
	Object createRangeElement(ReadGraph g, Resource domainElement) throws MappingException;
}
