package org.simantics.objmap;

/**
 * Listens modifications in a mapping.
 * @author Hannu Niemist
 */
public interface IMappingListener {
    /**
     * Called when some domain element is modified or created
     * and the mapping was previously up to date.
     */
	void domainModified();
	
	/**
     * Called when some range element is modified or created
     * and the mapping was previously up to date.
     */
	void rangeModified();
}
