package org.simantics.objmap;

import org.simantics.db.ReadGraph;
import org.simantics.db.Resource;

/**
 * Specifies the link types of new elements added to a mapping.
 * @author Hannu Niemist
 */
public interface IMappingSchema {
    /**
     * @return Link type that should be used for the element.
     */
	ILinkType linkTypeOfDomainElement(ReadGraph g, Resource element) throws MappingException;
	
	/**
     * @return Link type that should be used for the element.
     */
	ILinkType linkTypeOfRangeElement(Object element) throws MappingException;
}
