package org.simantics.objmap.annotations;

import java.lang.annotation.ElementType;
import java.lang.annotation.Retention;
import java.lang.annotation.RetentionPolicy;
import java.lang.annotation.Target;

import org.simantics.objmap.annotations.factories.RelatedValueRuleFactory;
import org.simantics.objmap.annotations.meta.HasFieldRuleFactory;

/**
 * Specifies a correspondence between a field and 
 * functional property.
 * @author Hannu Niemist
 */
@Retention(RetentionPolicy.RUNTIME)
@Target(ElementType.FIELD)
@HasFieldRuleFactory(RelatedValueRuleFactory.class)
public @interface RelatedValue {
	String value();
}
