package org.simantics.objmap.annotations.factories;

import org.simantics.db.Builtins;
import org.simantics.db.ReadGraph;
import org.simantics.db.Resource;

public class DataTypeUtils {
    
    public static Resource dataTypeOfClass(ReadGraph g, Class<?> clazz) {
        Builtins b = g.getBuiltins();
        if(clazz.equals(Double.class))
            return b.Double;
        else if(clazz.equals(String.class))
            return b.String;
        else if(clazz.equals(Integer.class))
            return b.Integer;
        else if(clazz.equals(Float.class))
            return b.Float;
        else if(clazz.equals(Boolean.class))
            return b.Boolean;
        else if(clazz.equals(Long.class))
            return b.Long;
        else if(clazz.equals(Byte.class))
            return b.Byte;
        
        else if(clazz.equals(double[].class))
            return b.DoubleArray;
        else if(clazz.equals(int[].class))
            return b.IntegerArray;
        else if(clazz.equals(byte[].class))
            return b.ByteArray;
        else if(clazz.equals(float[].class))
            return b.FloatArray;
        else if(clazz.equals(boolean[].class))
            return b.BooleanArray;
        else if(clazz.equals(String[].class))
            return b.StringArray;
        else if(clazz.equals(long[].class))
            return b.LongArray;
        else
            return null;
    }
    
}
