package org.simantics.objmap.annotations.factories;

import java.lang.annotation.Annotation;
import java.lang.reflect.Field;

import org.simantics.db.ReadGraph;
import org.simantics.db.exception.ResourceNotFoundException;
import org.simantics.db.exception.ServiceException;
import org.simantics.db.exception.ValidationException;
import org.simantics.objmap.IMappingRule;
import org.simantics.objmap.annotations.RelatedElement;
import org.simantics.objmap.rules.MappedElementRule;
import org.simantics.objmap.rules.domain.RelatedObjectAccessor;
import org.simantics.objmap.rules.factory.IFieldRuleFactory;
import org.simantics.objmap.rules.range.FieldAccessor;

public class RelatedElementRuleFactory implements IFieldRuleFactory {

    @Override
    public IMappingRule create(ReadGraph g, Annotation _annotation, Field field) throws ResourceNotFoundException, ValidationException, ServiceException {
        RelatedElement annotation = (RelatedElement)_annotation;
        return new MappedElementRule(
                new RelatedObjectAccessor(g.getResourceByURI(annotation.value())),
                new FieldAccessor<Object>(field)
                );
    }

}
