package org.simantics.objmap.annotations.factories;

import java.lang.annotation.Annotation;
import java.lang.reflect.Field;
import java.util.Collection;

import org.simantics.db.ReadGraph;
import org.simantics.db.exception.ResourceNotFoundException;
import org.simantics.db.exception.ServiceException;
import org.simantics.db.exception.ValidationException;
import org.simantics.objmap.IMappingRule;
import org.simantics.objmap.annotations.RelatedElements;
import org.simantics.objmap.rules.MappedElementsRule;
import org.simantics.objmap.rules.domain.RelatedObjectsAccessor;
import org.simantics.objmap.rules.factory.IFieldRuleFactory;
import org.simantics.objmap.rules.range.FieldAccessor;

public class RelatedElementsRuleFactory implements IFieldRuleFactory {

    @Override
    public IMappingRule create(ReadGraph g, Annotation _annotation, Field field) throws ResourceNotFoundException, ValidationException, ServiceException {
        RelatedElements annotation = (RelatedElements)_annotation;
        return new MappedElementsRule(
                new RelatedObjectsAccessor(g.getResourceByURI(annotation.value())),
                new FieldAccessor<Collection<Object>>(field)
                );
    }

}
