package org.simantics.objmap.annotations.factories;

import java.lang.annotation.Annotation;
import java.lang.reflect.Field;

import org.simantics.db.Builtins;
import org.simantics.db.ReadGraph;
import org.simantics.db.exception.ResourceNotFoundException;
import org.simantics.db.exception.ServiceException;
import org.simantics.db.exception.ValidationException;
import org.simantics.objmap.IMappingRule;
import org.simantics.objmap.annotations.RelatedValue;
import org.simantics.objmap.rules.ValueRule;
import org.simantics.objmap.rules.domain.RelatedValueAccessor;
import org.simantics.objmap.rules.factory.IFieldRuleFactory;
import org.simantics.objmap.rules.range.FieldAccessor;

public class RelatedValueRuleFactory implements IFieldRuleFactory {

    @Override
    public IMappingRule create(ReadGraph g, Annotation _annotation, Field field) throws ResourceNotFoundException, ValidationException, ServiceException {
        RelatedValue annotation = (RelatedValue)_annotation;
        Builtins b = g.getBuiltins();
        return new ValueRule(
                new RelatedValueAccessor(
                        g.getResourceByURI(annotation.value()), 
                        DataTypeUtils.dataTypeOfClass(g, field.getType())
                    ),
                new FieldAccessor<Object>(field)
                );
    }

}
