/**
 * 
 */
package org.simantics.objmap.impl;

import org.simantics.db.Resource;
import org.simantics.objmap.ILinkType;

/**
 * An indication that the domain element corresponds to the range element
 * in the mapping. The link type describes how source and target objects
 * are updated. There are additionally flags for dirtiness of the link.
 * @author Hannu Niemist
 */
public class Link {
	public ILinkType type;
	public Resource domainElement;
	public Object rangeElement;
	
	public boolean domainModified = false;
	public boolean rangeModified = false;
	public boolean removed = false;
	
	public Link(ILinkType type, Resource domainElement, Object rangeElement) {
		this.type = type;
		this.domainElement = domainElement;
		this.rangeElement = rangeElement;		
	}		
}