package org.simantics.objmap.rules.domain;

import org.simantics.db.ReadGraph;
import org.simantics.db.Resource;
import org.simantics.db.WriteGraph;
import org.simantics.objmap.MappingException;

/**
 * Provides access to some property of domain elements.
 * @author Hannu Niemist
 */
public interface IDomainAccessor<T> {
	T get(ReadGraph g, Resource element) throws MappingException;
	boolean set(WriteGraph g, Resource element, T value) throws MappingException;
}
